<template>
    <div class="page-container">
        <ValidationObserver
            ref="form"
        >
            <form>
                <div class="row broadcast-form-header">
                    <div class="col-md-4">
                        <div class="title">
                            {{ title }} User
                        </div>
                    </div>
                    <div class="col-md-8 float">
                        <b-btn
                            class="btn blue-btn float-right"
                            @click="submit()"
                        >
                            {{ title }}
                        </b-btn>
                    </div>
                </div>
                <div class="row">
                    <div class="full-width d-flex flex-wrap">
                        <validation-element
                            v-if="!item"
                            class="col-12 col-sm-6 mb-3"
                            label="Platforms"
                            type="select"
                            multiple
                        >
                            <b-select
                                v-model="selectedPlatforms"
                                class="form-control"
                                multiple
                                :options="platforms"
                            />
                        </validation-element>

                        <validation-element
                            v-model="user.role_id"
                            class="col-12 col-sm-6 mb-3"
                            label="Role"
                            type="select"
                            :options="userRoles"
                        />

                        <validation-element
                            v-model="user.name"
                            label="Name"
                            class="col-12 col-sm-6 mb-3"
                        />
                        
                        <validation-element
                            v-model="user.email"
                            label="Email"
                            class="col-12 col-sm-6 mb-3"
                        />
  
                        <validation-element
                            v-model="user.password"
                            :rules="{required: true, min: 8, confirmed: 'password'}"
                            vid="confirm_password"
                            input-type="password"
                            label="New Password"
                            class="col-12 col-sm-6 mb-3"
                        />

                        <validation-element
                            v-model="user.confirmPassword"
                            vid="password"
                            input-type="password"
                            :rules="{required: true, min: 8, confirmed: 'confirm_password'}"
                            label="Confirm Password"
                            class="col-12 col-sm-6 mb-3"
                        />

                        <validation-element
                            v-model="user.phone"
                            label="Phone"
                            class="col-12 col-sm-6 mb-3"
                        />
                    </div>
                </div>
            </form>
        </ValidationObserver>
    </div>
</template>

<script>
import ValidationElement from '@/components/elements/ValidationElement.vue';
import adminUsers from '@/mixins/admin/users.service';
import {USER_ROLES, PLATFORMS} from "@/store/constants";

export default {
    name: "AdminUserEdit",
    components: {
        ValidationElement
    },
    mixins: [adminUsers],
    props: {
        item: Object,
        title: String,
    },
    data: () => {
        return {
            user: {
                role_id: 1,
                name: '',
                email: '',
                phone: '',
                password: '',
                confirmPassword: '',
            },
            selectedPlatforms: [],
            platforms: PLATFORMS,
            userRoles: USER_ROLES
        };
    },
    created() {
        if(this.item) this.user = this.item
    },
    methods: {
        async submit() {
            const valid =  this.$refs.form
            const result = await valid.validate();
            const rules = !this.item ? this.selectedPlatforms.length : true
            if(result && rules) {
                const {password, name, phone, email, role_id} = this.user
                const payload = {
                    password,
                    name,
                    phone, 
                    email,
                    role_id
                }
                this.$emit('submit', {payload: payload, selected: this.selectedPlatforms})
                setTimeout(() => {
                    this.$refs.form.reset()
                }, 2000)
            } else this.getFormErrors(valid.errors)
               
        },
    },
};
</script>

<style scoped lang="scss">
    @import "../../../../css/colors.scss";

    .page-container {
        padding-top: 40px;
    }

    .title {
        font-size: 28px;
        font-weight: bold;
        color: $blue-color;
        margin-bottom: 15px;
    }

</style>
